{Ne pas activer ErrorIndicator de TJvValidators au Disign Time : sinon, crach ???}

unit MainFrm;

{.$I jvcl.inc}

interface

uses
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ComCtrls,
  EditBtn, ExtCtrls, DateTimePicker, JvValidators, JvErrorIndicator;

type

  { TfrmMain }

  TfrmMain = class(TForm)
    DateTimePicker1: TDateTimePicker;
    Image1: TImage;
    ImageList1: TImageList;
    JvCustomValidator2: TJvCustomValidator;
    Label1: TLabel;
    edRequired: TEdit;
    Label2: TLabel;
    edRequired10Chars: TEdit;
    Label3: TLabel;
    edRegExpr: TEdit;
    Label4: TLabel;
    edRange0to100: TEdit;
    Label5: TLabel;
    udRange0to100: TUpDown;
    btnProviderCheck: TButton;
    JvValidators1: TJvValidators;
    JvErrorIndicator1: TJvErrorIndicator;
    JvRequiredFieldValidator1: TJvRequiredFieldValidator;
    JvCustomValidator1: TJvCustomValidator;
    JvRegularExpressionValidator1: TJvRegularExpressionValidator;
    JvRangeValidator1: TJvRangeValidator;
    procedure btnProviderCheckClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure JvCustomValidator1Validate(Sender: TObject;
      ValueToValidate: Variant; var Valid: Boolean);
    procedure JvCustomValidator2Validate(Sender: TObject;
      ValueToValidate: Variant; var Valid: Boolean);
  private
    { Private declarations }
    procedure AddErrorIndicator(aControl:TControl;aImage:TImage;aMessage:String=''); overload;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses
  Variants;

{$R *.lfm}

{VOIR AUSSI l'utilisation de TJvErrorControl}

procedure TfrmMain.AddErrorIndicator(aControl: TControl; aImage: TImage;
  aMessage: String);
begin
  aImage.Top:=aControl.Top;
  aImage.Left:=aControl.Left+aControl.Width+10;
  aImage.Hint:=aMessage;
  aImage.ShowHint:=true;
end;

procedure TfrmMain.btnProviderCheckClick(Sender: TObject);
begin
    JvValidators1.Validate;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  {If DTP date is Null at disgn time => crash.}
  DateTimePicker1.Date:=DateTimePicker.NullDate;
  AddErrorIndicator(DateTimePicker1,Image1,'Date must be set');
  {Requered for TJvCustomValidator to work. D'ont wark at disagn time}
  JvValidators1.ErrorIndicator:=JvErrorIndicator1;
end;

procedure TfrmMain.JvCustomValidator1Validate(Sender: TObject;
  ValueToValidate: Variant; var Valid: Boolean);
begin
  Valid := not VarIsNull(ValueToValidate) and (Length(string(ValueToValidate)) >= 10);
end;

procedure TfrmMain.JvCustomValidator2Validate(Sender: TObject;
  ValueToValidate: Variant; var Valid: Boolean);
begin
  Valid := not DateTimePicker1.DateIsNull;
  Image1.Visible:=not Valid;
end;

end.
